Fix make-array transforms.
[sbcl.git] / make.sh
1 #!/bin/sh
2 set -e
3
4 LANG=C
5 LC_ALL=C
6 export LANG LC_ALL
7
8 # "When we build software, it's a good idea to have a reliable method
9 # for getting an executable from it. We want any two reconstructions
10 # starting from the same source to end up in the same result. That's
11 # just a basic intellectual premise."
12 #     -- Christian Queinnec, in _Lisp In Small Pieces_, p. 313
13
14 # This software is part of the SBCL system. See the README file for
15 # more information.
16 #
17 # This software is derived from the CMU CL system, which was
18 # written at Carnegie Mellon University and released into the
19 # public domain. The software is in the public domain and is
20 # provided with absolutely no warranty. See the COPYING and CREDITS
21 # files for more information.
22
23 # If you're cross-compiling, make-config.sh should "do the right
24 # thing" when run on the target machine, with the minor caveat that
25 # any --xc-host parameter should be suitable for the host machine
26 # instead of the target.
27 sh make-config.sh "$@" || exit $?
28
29 . output/prefix.def
30 . output/build-config
31
32 build_started=`date`
33 echo "//Starting build: $build_started"
34 # Apparently option parsing succeeded. Print out the results.
35 echo "//Options: --prefix='$SBCL_PREFIX' --xc-host='$SBCL_XC_HOST'"
36
37 # Enforce the source policy for no bogus whitespace
38 tools-for-build/canonicalize-whitespace
39
40 # The make-host-*.sh scripts are run on the cross-compilation host,
41 # and the make-target-*.sh scripts are run on the target machine. In
42 # ordinary compilation, we just do these phases consecutively on the
43 # same machine, but if you wanted to cross-compile from one machine
44 # which supports Common Lisp to another which does not (yet:-) support
45 # Common Lisp, you could do something like this:
46 #   Create copies of the source tree on both the host and the target.
47 #   Read the make-config.sh script carefully and emulate it by hand
48 #     on both machines (e.g. creating "target"-named symlinks to
49 #     identify the target architecture).
50 #   On the host system:
51 #     SBCL_XC_HOST=<whatever> sh make-host-1.sh
52 #   Copy src/runtime/genesis/*.h from the host system to the target
53 #     system.
54 #   On the target system:
55 #     sh make-target-1.sh
56 #   Copy src/runtime/sbcl.nm and output/stuff-groveled-from-headers.lisp
57 #     from the target system to the host system.
58 #   On the host system:
59 #     SBCL_XC_HOST=<whatever> sh make-host-2.sh
60 #   Copy output/cold-sbcl.core from the host system to the target system.
61 #   On the target system:
62 #     sh make-target-2.sh
63 #     sh make-target-contrib.sh
64 # Or, if you can set up the files somewhere shared (with NFS, AFS, or
65 # whatever) between the host machine and the target machine, the basic
66 # procedure above should still work, but you can skip the "copy" steps.
67 time sh make-host-1.sh
68 time sh make-target-1.sh
69 time sh make-host-2.sh
70 time sh make-target-2.sh
71 time sh make-target-contrib.sh
72
73 NCONTRIBS=`find contrib -name Makefile -print | wc -l`
74 NPASSED=`find obj/asdf-cache -name test-passed.test-report -print | wc -l`
75 echo
76 echo "The build seems to have finished successfully, including $NPASSED (out of $NCONTRIBS)"
77 echo "contributed modules. If you would like to run more extensive tests on"
78 echo "the new SBCL, you can try:"
79 echo
80 echo "  cd tests && sh ./run-tests.sh"
81 echo
82 echo "  (All tests should pass on x86/Linux, x86/FreeBSD4, and ppc/Darwin. On"
83 echo "  other platforms some failures are currently expected; patches welcome"
84 echo "  as always.)"
85 echo
86 echo "To build documentation:"
87 echo
88 echo "  cd doc/manual && make"
89 echo
90 echo "To install SBCL (more information in INSTALL):"
91 echo
92 echo "  sh install.sh"
93
94 # This is probably the best place to ensure people will see this.
95 if test -n "$legacy_xc_spec"
96 then
97     echo <<EOF
98 ******************************************************************************
99 **
100 **  Old-style XC-host specification detected: '$SBCL_XC_HOST'
101 **
102 **  Since 1.0.41.45 SBCL expects the XC-host to be specified using
103 **  the --xc-host='myhost' command line option, not with a positional
104 **  argument. The legacy style still works, but will not be supported
105 **  indefinitely. Please update your build procedure.
106 **
107 ******************************************************************************
108 EOF
109 fi
110
111 build_finished=`date`
112 echo
113 echo "//build started:  $build_started"
114 echo "//build finished: $build_finished"